#ifndef EVENTHISTORY_H
#define EVENTHISTORY_H

#include <qvariant.h>


#include <Qt3Support/Q3Header>
#include <Qt3Support/Q3ListView>
#include <Qt3Support/Q3MimeSourceFactory>
#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QDialog>
#include <QtGui/QHBoxLayout>
#include <QtGui/QHeaderView>
#include <QtGui/QPushButton>
#include <QtGui/QSpacerItem>
#include <QtGui/QVBoxLayout>
#include "wpamsg.h"

QT_BEGIN_NAMESPACE

class Ui_EventHistory
{
public:
    QVBoxLayout *vboxLayout;
    Q3ListView *eventListView;
    QHBoxLayout *hboxLayout;
    QSpacerItem *spacer3;
    QPushButton *closeButton;

    void setupUi(QDialog *EventHistory)
    {
        if (EventHistory->objectName().isEmpty())
            EventHistory->setObjectName(QString::fromUtf8("EventHistory"));
        EventHistory->resize(533, 285);
        vboxLayout = new QVBoxLayout(EventHistory);
        vboxLayout->setSpacing(6);
        vboxLayout->setContentsMargins(11, 11, 11, 11);
        vboxLayout->setObjectName(QString::fromUtf8("vboxLayout"));
        eventListView = new Q3ListView(EventHistory);
        eventListView->addColumn(QApplication::translate("EventHistory", "Timestamp", 0, QApplication::UnicodeUTF8));
        eventListView->header()->setClickEnabled(true, eventListView->header()->count() - 1);
        eventListView->header()->setResizeEnabled(true, eventListView->header()->count() - 1);
        eventListView->addColumn(QApplication::translate("EventHistory", "Message", 0, QApplication::UnicodeUTF8));
        eventListView->header()->setClickEnabled(true, eventListView->header()->count() - 1);
        eventListView->header()->setResizeEnabled(true, eventListView->header()->count() - 1);
        eventListView->setObjectName(QString::fromUtf8("eventListView"));
        QSizePolicy sizePolicy(static_cast<QSizePolicy::Policy>(7), static_cast<QSizePolicy::Policy>(7));
        sizePolicy.setHorizontalStretch(0);
        sizePolicy.setVerticalStretch(0);
        sizePolicy.setHeightForWidth(eventListView->sizePolicy().hasHeightForWidth());
        eventListView->setSizePolicy(sizePolicy);
        eventListView->setResizePolicy(Q3ScrollView::Manual);
        eventListView->setSelectionMode(Q3ListView::NoSelection);
        eventListView->setResizeMode(Q3ListView::LastColumn);

        vboxLayout->addWidget(eventListView);

        hboxLayout = new QHBoxLayout();
        hboxLayout->setSpacing(6);
        hboxLayout->setObjectName(QString::fromUtf8("hboxLayout"));
        spacer3 = new QSpacerItem(20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum);

        hboxLayout->addItem(spacer3);

        closeButton = new QPushButton(EventHistory);
        closeButton->setObjectName(QString::fromUtf8("closeButton"));

        hboxLayout->addWidget(closeButton);


        vboxLayout->addLayout(hboxLayout);


        retranslateUi(EventHistory);
        QObject::connect(closeButton, SIGNAL(clicked()), EventHistory, SLOT(close()));

        QMetaObject::connectSlotsByName(EventHistory);
    } // setupUi

    void retranslateUi(QDialog *EventHistory)
    {
        EventHistory->setWindowTitle(QApplication::translate("EventHistory", "Event history", 0, QApplication::UnicodeUTF8));
        eventListView->header()->setLabel(0, QApplication::translate("EventHistory", "Timestamp", 0, QApplication::UnicodeUTF8));
        eventListView->header()->setLabel(1, QApplication::translate("EventHistory", "Message", 0, QApplication::UnicodeUTF8));
        closeButton->setText(QApplication::translate("EventHistory", "Close", 0, QApplication::UnicodeUTF8));
    } // retranslateUi

};

namespace Ui {
    class EventHistory: public Ui_EventHistory {};
} // namespace Ui

QT_END_NAMESPACE

class EventHistory : public QDialog, public Ui::EventHistory
{
    Q_OBJECT

public:
    EventHistory(QWidget* parent = 0, const char* name = 0, bool modal = false, Qt::WindowFlags fl = 0);
    ~EventHistory();

public slots:
    virtual void addEvents( WpaMsgList msgs );
    virtual void addEvent( WpaMsg msg );

protected slots:
    virtual void languageChange();

private:
    void init();
    void destroy();

};

#endif // EVENTHISTORY_H
