#ifndef NETWORKCONFIG_H
#define NETWORKCONFIG_H

#include <qvariant.h>

class WpaGui;

#include <Qt3Support/Q3ButtonGroup>
#include <Qt3Support/Q3Frame>
#include <Qt3Support/Q3MimeSourceFactory>
#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QComboBox>
#include <QtGui/QDialog>
#include <QtGui/QGridLayout>
#include <QtGui/QHeaderView>
#include <QtGui/QLabel>
#include <QtGui/QLineEdit>
#include <QtGui/QPushButton>
#include <QtGui/QRadioButton>
#include <QtGui/QSpacerItem>
#include <Qt3Support/Q3ListViewItemIterator>

QT_BEGIN_NAMESPACE

class Ui_NetworkConfig
{
public:
    QGridLayout *gridLayout;
    QPushButton *cancelButton;
    Q3Frame *frame9;
    QGridLayout *gridLayout1;
    QLabel *textLabel0;
    QLineEdit *ssidEdit;
    QLabel *textLabel1;
    QLineEdit *idstrEdit;
    QLabel *textLabel2;
    QComboBox *authSelect;
    QLabel *textLabel3;
    QComboBox *encrSelect;
    QLabel *textLabel4;
    QLineEdit *pskEdit;
    QLabel *textLabel5;
    QComboBox *eapSelect;
    QLabel *textLabel6;
    QLineEdit *identityEdit;
    QLabel *textLabel7;
    QLineEdit *passwordEdit;
    QLabel *textLabel1_2;
    QLineEdit *cacertEdit;
    Q3ButtonGroup *buttonGroup1;
    QGridLayout *gridLayout2;
    QRadioButton *wep0Radio;
    QRadioButton *wep1Radio;
    QRadioButton *wep3Radio;
    QRadioButton *wep2Radio;
    QLineEdit *wep0Edit;
    QLineEdit *wep1Edit;
    QLineEdit *wep2Edit;
    QLineEdit *wep3Edit;
    QSpacerItem *spacer5;
    QPushButton *addButton;
    QPushButton *removeButton;

    void setupUi(QDialog *NetworkConfig)
    {
        if (NetworkConfig->objectName().isEmpty())
            NetworkConfig->setObjectName(QString::fromUtf8("NetworkConfig"));
        NetworkConfig->resize(380, 430);
        gridLayout = new QGridLayout(NetworkConfig);
        gridLayout->setSpacing(6);
        gridLayout->setContentsMargins(11, 11, 11, 11);
        gridLayout->setObjectName(QString::fromUtf8("gridLayout"));
        cancelButton = new QPushButton(NetworkConfig);
        cancelButton->setObjectName(QString::fromUtf8("cancelButton"));

        gridLayout->addWidget(cancelButton, 1, 3, 1, 1);

        frame9 = new Q3Frame(NetworkConfig);
        frame9->setObjectName(QString::fromUtf8("frame9"));
        frame9->setFrameShape(QFrame::StyledPanel);
        frame9->setFrameShadow(QFrame::Raised);
        gridLayout1 = new QGridLayout(frame9);
        gridLayout1->setSpacing(6);
        gridLayout1->setContentsMargins(11, 11, 11, 11);
        gridLayout1->setObjectName(QString::fromUtf8("gridLayout1"));
        textLabel0 = new QLabel(frame9);
        textLabel0->setObjectName(QString::fromUtf8("textLabel0"));
        textLabel0->setWordWrap(false);

        gridLayout1->addWidget(textLabel0, 0, 0, 1, 1);

        ssidEdit = new QLineEdit(frame9);
        ssidEdit->setObjectName(QString::fromUtf8("ssidEdit"));

        gridLayout1->addWidget(ssidEdit, 0, 1, 1, 1);

        textLabel1 = new QLabel(frame9);
        textLabel1->setObjectName(QString::fromUtf8("textLabel1"));
        textLabel1->setWordWrap(false);

        gridLayout1->addWidget(textLabel1, 1, 0, 1, 1);

        idstrEdit = new QLineEdit(frame9);
        idstrEdit->setObjectName(QString::fromUtf8("idstrEdit"));

        gridLayout1->addWidget(idstrEdit, 1, 1, 1, 1);

        textLabel2 = new QLabel(frame9);
        textLabel2->setObjectName(QString::fromUtf8("textLabel2"));
        textLabel2->setWordWrap(false);

        gridLayout1->addWidget(textLabel2, 2, 0, 1, 1);

        authSelect = new QComboBox(frame9);
        authSelect->setObjectName(QString::fromUtf8("authSelect"));

        gridLayout1->addWidget(authSelect, 2, 1, 1, 1);

        textLabel3 = new QLabel(frame9);
        textLabel3->setObjectName(QString::fromUtf8("textLabel3"));
        textLabel3->setWordWrap(false);

        gridLayout1->addWidget(textLabel3, 3, 0, 1, 1);

        encrSelect = new QComboBox(frame9);
        encrSelect->setObjectName(QString::fromUtf8("encrSelect"));

        gridLayout1->addWidget(encrSelect, 3, 1, 1, 1);

        textLabel4 = new QLabel(frame9);
        textLabel4->setObjectName(QString::fromUtf8("textLabel4"));
        textLabel4->setWordWrap(false);

        gridLayout1->addWidget(textLabel4, 4, 0, 1, 1);

        pskEdit = new QLineEdit(frame9);
        pskEdit->setObjectName(QString::fromUtf8("pskEdit"));
        pskEdit->setEnabled(false);
        pskEdit->setEchoMode(QLineEdit::Password);

        gridLayout1->addWidget(pskEdit, 4, 1, 1, 1);

        textLabel5 = new QLabel(frame9);
        textLabel5->setObjectName(QString::fromUtf8("textLabel5"));
        textLabel5->setWordWrap(false);

        gridLayout1->addWidget(textLabel5, 5, 0, 1, 1);

        eapSelect = new QComboBox(frame9);
        eapSelect->setObjectName(QString::fromUtf8("eapSelect"));
        eapSelect->setEnabled(false);

        gridLayout1->addWidget(eapSelect, 5, 1, 1, 1);

        textLabel6 = new QLabel(frame9);
        textLabel6->setObjectName(QString::fromUtf8("textLabel6"));
        textLabel6->setWordWrap(false);

        gridLayout1->addWidget(textLabel6, 6, 0, 1, 1);

        identityEdit = new QLineEdit(frame9);
        identityEdit->setObjectName(QString::fromUtf8("identityEdit"));
        identityEdit->setEnabled(false);

        gridLayout1->addWidget(identityEdit, 6, 1, 1, 1);

        textLabel7 = new QLabel(frame9);
        textLabel7->setObjectName(QString::fromUtf8("textLabel7"));
        textLabel7->setWordWrap(false);

        gridLayout1->addWidget(textLabel7, 7, 0, 1, 1);

        passwordEdit = new QLineEdit(frame9);
        passwordEdit->setObjectName(QString::fromUtf8("passwordEdit"));
        passwordEdit->setEnabled(false);
        passwordEdit->setEchoMode(QLineEdit::Password);

        gridLayout1->addWidget(passwordEdit, 7, 1, 1, 1);

        textLabel1_2 = new QLabel(frame9);
        textLabel1_2->setObjectName(QString::fromUtf8("textLabel1_2"));
        textLabel1_2->setWordWrap(false);

        gridLayout1->addWidget(textLabel1_2, 8, 0, 1, 1);

        cacertEdit = new QLineEdit(frame9);
        cacertEdit->setObjectName(QString::fromUtf8("cacertEdit"));
        cacertEdit->setEnabled(false);

        gridLayout1->addWidget(cacertEdit, 8, 1, 1, 1);

        buttonGroup1 = new Q3ButtonGroup(frame9);
        buttonGroup1->setObjectName(QString::fromUtf8("buttonGroup1"));
        buttonGroup1->setEnabled(true);
        buttonGroup1->setColumnLayout(0, Qt::Vertical);
        buttonGroup1->layout()->setSpacing(6);
        buttonGroup1->layout()->setContentsMargins(11, 11, 11, 11);
        gridLayout2 = new QGridLayout();
        QBoxLayout *boxlayout = qobject_cast<QBoxLayout *>(buttonGroup1->layout());
        if (boxlayout)
            boxlayout->addLayout(gridLayout2);
        gridLayout2->setAlignment(Qt::AlignTop);
        gridLayout2->setObjectName(QString::fromUtf8("gridLayout2"));
        wep0Radio = new QRadioButton(buttonGroup1);
        wep0Radio->setObjectName(QString::fromUtf8("wep0Radio"));
        wep0Radio->setEnabled(false);

        gridLayout2->addWidget(wep0Radio, 0, 0, 1, 1);

        wep1Radio = new QRadioButton(buttonGroup1);
        wep1Radio->setObjectName(QString::fromUtf8("wep1Radio"));
        wep1Radio->setEnabled(false);

        gridLayout2->addWidget(wep1Radio, 1, 0, 1, 1);

        wep3Radio = new QRadioButton(buttonGroup1);
        wep3Radio->setObjectName(QString::fromUtf8("wep3Radio"));
        wep3Radio->setEnabled(false);

        gridLayout2->addWidget(wep3Radio, 3, 0, 1, 1);

        wep2Radio = new QRadioButton(buttonGroup1);
        wep2Radio->setObjectName(QString::fromUtf8("wep2Radio"));
        wep2Radio->setEnabled(false);

        gridLayout2->addWidget(wep2Radio, 2, 0, 1, 1);

        wep0Edit = new QLineEdit(buttonGroup1);
        wep0Edit->setObjectName(QString::fromUtf8("wep0Edit"));
        wep0Edit->setEnabled(false);

        gridLayout2->addWidget(wep0Edit, 0, 1, 1, 1);

        wep1Edit = new QLineEdit(buttonGroup1);
        wep1Edit->setObjectName(QString::fromUtf8("wep1Edit"));
        wep1Edit->setEnabled(false);

        gridLayout2->addWidget(wep1Edit, 1, 1, 1, 1);

        wep2Edit = new QLineEdit(buttonGroup1);
        wep2Edit->setObjectName(QString::fromUtf8("wep2Edit"));
        wep2Edit->setEnabled(false);

        gridLayout2->addWidget(wep2Edit, 2, 1, 1, 1);

        wep3Edit = new QLineEdit(buttonGroup1);
        wep3Edit->setObjectName(QString::fromUtf8("wep3Edit"));
        wep3Edit->setEnabled(false);

        gridLayout2->addWidget(wep3Edit, 3, 1, 1, 1);


        gridLayout1->addWidget(buttonGroup1, 9, 0, 1, 2);


        gridLayout->addWidget(frame9, 0, 0, 1, 4);

        spacer5 = new QSpacerItem(130, 20, QSizePolicy::Expanding, QSizePolicy::Minimum);

        gridLayout->addItem(spacer5, 1, 0, 1, 1);

        addButton = new QPushButton(NetworkConfig);
        addButton->setObjectName(QString::fromUtf8("addButton"));

        gridLayout->addWidget(addButton, 1, 1, 1, 1);

        removeButton = new QPushButton(NetworkConfig);
        removeButton->setObjectName(QString::fromUtf8("removeButton"));
        removeButton->setEnabled(false);

        gridLayout->addWidget(removeButton, 1, 2, 1, 1);

        QWidget::setTabOrder(ssidEdit, idstrEdit);
        QWidget::setTabOrder(idstrEdit, authSelect);
        QWidget::setTabOrder(authSelect, encrSelect);
        QWidget::setTabOrder(encrSelect, pskEdit);
        QWidget::setTabOrder(pskEdit, eapSelect);
        QWidget::setTabOrder(eapSelect, identityEdit);
        QWidget::setTabOrder(identityEdit, passwordEdit);
        QWidget::setTabOrder(passwordEdit, cacertEdit);
        QWidget::setTabOrder(cacertEdit, wep0Radio);
        QWidget::setTabOrder(wep0Radio, wep1Radio);
        QWidget::setTabOrder(wep1Radio, wep2Radio);
        QWidget::setTabOrder(wep2Radio, wep3Radio);
        QWidget::setTabOrder(wep3Radio, wep0Edit);
        QWidget::setTabOrder(wep0Edit, wep1Edit);
        QWidget::setTabOrder(wep1Edit, wep2Edit);
        QWidget::setTabOrder(wep2Edit, wep3Edit);
        QWidget::setTabOrder(wep3Edit, addButton);
        QWidget::setTabOrder(addButton, removeButton);
        QWidget::setTabOrder(removeButton, cancelButton);

        retranslateUi(NetworkConfig);
        QObject::connect(authSelect, SIGNAL(activated(int)), NetworkConfig, SLOT(authChanged(int)));
        QObject::connect(cancelButton, SIGNAL(clicked()), NetworkConfig, SLOT(close()));
        QObject::connect(addButton, SIGNAL(clicked()), NetworkConfig, SLOT(addNetwork()));
        QObject::connect(encrSelect, SIGNAL(activated(QString)), NetworkConfig, SLOT(encrChanged(QString)));
        QObject::connect(removeButton, SIGNAL(clicked()), NetworkConfig, SLOT(removeNetwork()));

        QMetaObject::connectSlotsByName(NetworkConfig);
    } // setupUi

    void retranslateUi(QDialog *NetworkConfig)
    {
        NetworkConfig->setWindowTitle(QApplication::translate("NetworkConfig", "NetworkConfig", 0, QApplication::UnicodeUTF8));
        cancelButton->setText(QApplication::translate("NetworkConfig", "Cancel", 0, QApplication::UnicodeUTF8));
        textLabel0->setText(QApplication::translate("NetworkConfig", "SSID", 0, QApplication::UnicodeUTF8));
        ssidEdit->setText(QString());
#ifndef QT_NO_TOOLTIP
        ssidEdit->setProperty("toolTip", QVariant(QApplication::translate("NetworkConfig", "Network name (Service Set IDentifier)", 0, QApplication::UnicodeUTF8)));
#endif // QT_NO_TOOLTIP
        textLabel1->setText(QApplication::translate("NetworkConfig", "Network ID", 0, QApplication::UnicodeUTF8));
        idstrEdit->setText(QString());
#ifndef QT_NO_TOOLTIP
        idstrEdit->setProperty("toolTip", QVariant(QApplication::translate("NetworkConfig", "Network Identification String", 0, QApplication::UnicodeUTF8)));
#endif // QT_NO_TOOLTIP
        textLabel2->setText(QApplication::translate("NetworkConfig", "Authentication", 0, QApplication::UnicodeUTF8));
        authSelect->clear();
        authSelect->insertItems(0, QStringList()
         << QApplication::translate("NetworkConfig", "Plaintext or static WEP", 0, QApplication::UnicodeUTF8)
         << QApplication::translate("NetworkConfig", "IEEE 802.1X", 0, QApplication::UnicodeUTF8)
         << QApplication::translate("NetworkConfig", "WPA-Personal (PSK)", 0, QApplication::UnicodeUTF8)
         << QApplication::translate("NetworkConfig", "WPA-Enterprise (EAP)", 0, QApplication::UnicodeUTF8)
         << QApplication::translate("NetworkConfig", "WPA2-Personal (PSK)", 0, QApplication::UnicodeUTF8)
         << QApplication::translate("NetworkConfig", "WPA2-Enterprise (EAP)", 0, QApplication::UnicodeUTF8)
        );
        textLabel3->setText(QApplication::translate("NetworkConfig", "Encryption", 0, QApplication::UnicodeUTF8));
        encrSelect->clear();
        encrSelect->insertItems(0, QStringList()
         << QApplication::translate("NetworkConfig", "None", 0, QApplication::UnicodeUTF8)
         << QApplication::translate("NetworkConfig", "WEP", 0, QApplication::UnicodeUTF8)
         << QApplication::translate("NetworkConfig", "TKIP", 0, QApplication::UnicodeUTF8)
         << QApplication::translate("NetworkConfig", "CCMP", 0, QApplication::UnicodeUTF8)
        );
        textLabel4->setText(QApplication::translate("NetworkConfig", "PSK", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        pskEdit->setProperty("toolTip", QVariant(QApplication::translate("NetworkConfig", "WPA/WPA2 pre-shared key or passphrase", 0, QApplication::UnicodeUTF8)));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        pskEdit->setProperty("whatsThis", QVariant(QString()));
#endif // QT_NO_WHATSTHIS
        textLabel5->setText(QApplication::translate("NetworkConfig", "EAP method", 0, QApplication::UnicodeUTF8));
        textLabel6->setText(QApplication::translate("NetworkConfig", "Identity", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        identityEdit->setProperty("toolTip", QVariant(QApplication::translate("NetworkConfig", "Username/Identity for EAP methods", 0, QApplication::UnicodeUTF8)));
#endif // QT_NO_TOOLTIP
        textLabel7->setText(QApplication::translate("NetworkConfig", "Password", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        passwordEdit->setProperty("toolTip", QVariant(QApplication::translate("NetworkConfig", "Password for EAP methods", 0, QApplication::UnicodeUTF8)));
#endif // QT_NO_TOOLTIP
        textLabel1_2->setText(QApplication::translate("NetworkConfig", "CA certificate", 0, QApplication::UnicodeUTF8));
        buttonGroup1->setTitle(QApplication::translate("NetworkConfig", "WEP keys", 0, QApplication::UnicodeUTF8));
        wep0Radio->setText(QApplication::translate("NetworkConfig", "key 0", 0, QApplication::UnicodeUTF8));
        wep1Radio->setText(QApplication::translate("NetworkConfig", "key 1", 0, QApplication::UnicodeUTF8));
        wep3Radio->setText(QApplication::translate("NetworkConfig", "key 3", 0, QApplication::UnicodeUTF8));
        wep2Radio->setText(QApplication::translate("NetworkConfig", "key 2", 0, QApplication::UnicodeUTF8));
        addButton->setText(QApplication::translate("NetworkConfig", "Add", 0, QApplication::UnicodeUTF8));
        removeButton->setText(QApplication::translate("NetworkConfig", "Remove", 0, QApplication::UnicodeUTF8));
    } // retranslateUi

};

namespace Ui {
    class NetworkConfig: public Ui_NetworkConfig {};
} // namespace Ui

QT_END_NAMESPACE

class NetworkConfig : public QDialog, public Ui::NetworkConfig
{
    Q_OBJECT

public:
    NetworkConfig(QWidget* parent = 0, const char* name = 0, bool modal = false, Qt::WindowFlags fl = 0);
    ~NetworkConfig();

    virtual void paramsFromScanResults( Q3ListViewItem * sel );
    virtual void setWpaGui( WpaGui * _wpagui );
    virtual int setNetworkParam( int id, const char * field, const char * value, bool quote );
    virtual void paramsFromConfig( int network_id );
    virtual void newNetwork();

public slots:
    virtual void authChanged( int sel );
    virtual void addNetwork();
    virtual void encrChanged( const QString & sel );
    virtual void writeWepKey( int network_id, QLineEdit * edit, int id );
    virtual void removeNetwork();

protected slots:
    virtual void languageChange();

private:
    WpaGui *wpagui;
    int edit_network_id;
    bool new_network;

    void init();
    virtual void wepEnabled( bool enabled );
    virtual void getEapCapa();

};

#endif // NETWORKCONFIG_H
