#ifndef SCANRESULTS_H
#define SCANRESULTS_H

#include <qvariant.h>

class WpaGui;

#include <Qt3Support/Q3Header>
#include <Qt3Support/Q3ListView>
#include <Qt3Support/Q3MimeSourceFactory>
#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QDialog>
#include <QtGui/QHBoxLayout>
#include <QtGui/QHeaderView>
#include <QtGui/QPushButton>
#include <QtGui/QSpacerItem>
#include <QtGui/QVBoxLayout>

QT_BEGIN_NAMESPACE

class Ui_ScanResults
{
public:
    QVBoxLayout *vboxLayout;
    Q3ListView *scanResultsView;
    QHBoxLayout *hboxLayout;
    QSpacerItem *spacer6;
    QPushButton *scanButton;
    QPushButton *closeButton;

    void setupUi(QDialog *ScanResults)
    {
        if (ScanResults->objectName().isEmpty())
            ScanResults->setObjectName(QString::fromUtf8("ScanResults"));
        ScanResults->resize(452, 225);
        vboxLayout = new QVBoxLayout(ScanResults);
        vboxLayout->setSpacing(6);
        vboxLayout->setContentsMargins(11, 11, 11, 11);
        vboxLayout->setObjectName(QString::fromUtf8("vboxLayout"));
        scanResultsView = new Q3ListView(ScanResults);
        scanResultsView->addColumn(QApplication::translate("ScanResults", "SSID", 0, QApplication::UnicodeUTF8));
        scanResultsView->header()->setClickEnabled(true, scanResultsView->header()->count() - 1);
        scanResultsView->header()->setResizeEnabled(true, scanResultsView->header()->count() - 1);
        scanResultsView->addColumn(QApplication::translate("ScanResults", "BSSID", 0, QApplication::UnicodeUTF8));
        scanResultsView->header()->setClickEnabled(true, scanResultsView->header()->count() - 1);
        scanResultsView->header()->setResizeEnabled(true, scanResultsView->header()->count() - 1);
        scanResultsView->addColumn(QApplication::translate("ScanResults", "frequency", 0, QApplication::UnicodeUTF8));
        scanResultsView->header()->setClickEnabled(true, scanResultsView->header()->count() - 1);
        scanResultsView->header()->setResizeEnabled(true, scanResultsView->header()->count() - 1);
        scanResultsView->addColumn(QApplication::translate("ScanResults", "signal", 0, QApplication::UnicodeUTF8));
        scanResultsView->header()->setClickEnabled(true, scanResultsView->header()->count() - 1);
        scanResultsView->header()->setResizeEnabled(true, scanResultsView->header()->count() - 1);
        scanResultsView->addColumn(QApplication::translate("ScanResults", "flags", 0, QApplication::UnicodeUTF8));
        scanResultsView->header()->setClickEnabled(true, scanResultsView->header()->count() - 1);
        scanResultsView->header()->setResizeEnabled(true, scanResultsView->header()->count() - 1);
        scanResultsView->setObjectName(QString::fromUtf8("scanResultsView"));
        scanResultsView->setFrameShape(QFrame::StyledPanel);
        scanResultsView->setFrameShadow(QFrame::Sunken);

        vboxLayout->addWidget(scanResultsView);

        hboxLayout = new QHBoxLayout();
        hboxLayout->setSpacing(6);
        hboxLayout->setObjectName(QString::fromUtf8("hboxLayout"));
        spacer6 = new QSpacerItem(50, 20, QSizePolicy::Expanding, QSizePolicy::Minimum);

        hboxLayout->addItem(spacer6);

        scanButton = new QPushButton(ScanResults);
        scanButton->setObjectName(QString::fromUtf8("scanButton"));

        hboxLayout->addWidget(scanButton);

        closeButton = new QPushButton(ScanResults);
        closeButton->setObjectName(QString::fromUtf8("closeButton"));

        hboxLayout->addWidget(closeButton);


        vboxLayout->addLayout(hboxLayout);


        retranslateUi(ScanResults);
        QObject::connect(closeButton, SIGNAL(clicked()), ScanResults, SLOT(close()));
        QObject::connect(scanButton, SIGNAL(clicked()), ScanResults, SLOT(scanRequest()));
        QObject::connect(scanResultsView, SIGNAL(doubleClicked(Q3ListViewItem*)), ScanResults, SLOT(bssSelected(Q3ListViewItem*)));

        QMetaObject::connectSlotsByName(ScanResults);
    } // setupUi

    void retranslateUi(QDialog *ScanResults)
    {
        ScanResults->setWindowTitle(QApplication::translate("ScanResults", "Scan results", 0, QApplication::UnicodeUTF8));
        scanResultsView->header()->setLabel(0, QApplication::translate("ScanResults", "SSID", 0, QApplication::UnicodeUTF8));
        scanResultsView->header()->setLabel(1, QApplication::translate("ScanResults", "BSSID", 0, QApplication::UnicodeUTF8));
        scanResultsView->header()->setLabel(2, QApplication::translate("ScanResults", "frequency", 0, QApplication::UnicodeUTF8));
        scanResultsView->header()->setLabel(3, QApplication::translate("ScanResults", "signal", 0, QApplication::UnicodeUTF8));
        scanResultsView->header()->setLabel(4, QApplication::translate("ScanResults", "flags", 0, QApplication::UnicodeUTF8));
        scanButton->setText(QApplication::translate("ScanResults", "Scan", 0, QApplication::UnicodeUTF8));
        closeButton->setText(QApplication::translate("ScanResults", "Close", 0, QApplication::UnicodeUTF8));
    } // retranslateUi

};

namespace Ui {
    class ScanResults: public Ui_ScanResults {};
} // namespace Ui

QT_END_NAMESPACE

class ScanResults : public QDialog, public Ui::ScanResults
{
    Q_OBJECT

public:
    ScanResults(QWidget* parent = 0, const char* name = 0, bool modal = false, Qt::WindowFlags fl = 0);
    ~ScanResults();

public slots:
    virtual void setWpaGui( WpaGui * _wpagui );
    virtual void updateResults();
    virtual void scanRequest();
    virtual void getResults();
    virtual void bssSelected( Q3ListViewItem * sel );

protected slots:
    virtual void languageChange();

private:
    WpaGui *wpagui;
    QTimer *timer;

    void init();
    void destroy();

};

#endif // SCANRESULTS_H
