#ifndef WPAGUI_H
#define WPAGUI_H

#include <qvariant.h>

class UserDataRequest;

#include <Qt3Support/Q3Frame>
#include <Qt3Support/Q3MainWindow>
#include <Qt3Support/Q3MimeSourceFactory>
#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QComboBox>
#include <QtGui/QGridLayout>
#include <QtGui/QHeaderView>
#include <QtGui/QLabel>
#include <QtGui/QMenu>
#include <QtGui/QMenuBar>
#include <QtGui/QPushButton>
#include <QtGui/QSpacerItem>
#include <QtGui/QWidget>
#include <QtCore/QSocketNotifier>
#include <QtCore/QTimer>
#include "eventhistory.h"
#include "scanresults.h"
#include "wpamsg.h"

QT_BEGIN_NAMESPACE

class Ui_WpaGui
{
public:
    QAction *fileExitAction;
    QAction *helpContentsAction;
    QAction *helpIndexAction;
    QAction *helpAboutAction;
    QAction *fileEventHistoryAction;
    QAction *fileAdd_NetworkAction;
    QAction *fileEdit_networkAction;
    QWidget *widget;
    QGridLayout *gridLayout;
    QLabel *textLabel16;
    QComboBox *adapterSelect;
    QLabel *textLabel8;
    QComboBox *networkSelect;
    Q3Frame *frame3;
    QGridLayout *gridLayout1;
    QLabel *textLabel1;
    QLabel *textLabel2;
    QLabel *textLabel3;
    QLabel *textLabel4;
    QLabel *textLabel5;
    QLabel *textLabel6;
    QLabel *textLabel7;
    QLabel *textStatus;
    QLabel *textLastMessage;
    QLabel *textAuthentication;
    QLabel *textEncryption;
    QLabel *textSsid;
    QLabel *textBssid;
    QLabel *textIpAddress;
    QSpacerItem *spacer7;
    QPushButton *connectButton;
    QPushButton *disconnectButton;
    QPushButton *scanButton;
    QMenuBar *MenuBar;
    QMenu *fileMenu;
    QMenu *helpMenu;

    void setupUi(Q3MainWindow *WpaGui)
    {
        if (WpaGui->objectName().isEmpty())
            WpaGui->setObjectName(QString::fromUtf8("WpaGui"));
        WpaGui->resize(279, 308);
        fileExitAction = new QAction(WpaGui);
        fileExitAction->setObjectName(QString::fromUtf8("fileExitAction"));
        fileExitAction->setName("fileExitAction");
        helpContentsAction = new QAction(WpaGui);
        helpContentsAction->setObjectName(QString::fromUtf8("helpContentsAction"));
        helpContentsAction->setName("helpContentsAction");
        helpContentsAction->setEnabled(false);
        helpIndexAction = new QAction(WpaGui);
        helpIndexAction->setObjectName(QString::fromUtf8("helpIndexAction"));
        helpIndexAction->setName("helpIndexAction");
        helpIndexAction->setEnabled(false);
        helpAboutAction = new QAction(WpaGui);
        helpAboutAction->setObjectName(QString::fromUtf8("helpAboutAction"));
        helpAboutAction->setName("helpAboutAction");
        fileEventHistoryAction = new QAction(WpaGui);
        fileEventHistoryAction->setObjectName(QString::fromUtf8("fileEventHistoryAction"));
        fileEventHistoryAction->setName("fileEventHistoryAction");
        fileAdd_NetworkAction = new QAction(WpaGui);
        fileAdd_NetworkAction->setObjectName(QString::fromUtf8("fileAdd_NetworkAction"));
        fileAdd_NetworkAction->setName("fileAdd_NetworkAction");
        fileEdit_networkAction = new QAction(WpaGui);
        fileEdit_networkAction->setObjectName(QString::fromUtf8("fileEdit_networkAction"));
        fileEdit_networkAction->setName("fileEdit_networkAction");
        widget = new QWidget(WpaGui);
        widget->setObjectName(QString::fromUtf8("widget"));
        gridLayout = new QGridLayout(widget);
        gridLayout->setSpacing(6);
        gridLayout->setContentsMargins(11, 11, 11, 11);
        gridLayout->setObjectName(QString::fromUtf8("gridLayout"));
        gridLayout->setContentsMargins(0, 0, 0, 0);
        textLabel16 = new QLabel(widget);
        textLabel16->setObjectName(QString::fromUtf8("textLabel16"));
        textLabel16->setWordWrap(false);

        gridLayout->addWidget(textLabel16, 0, 0, 1, 2);

        adapterSelect = new QComboBox(widget);
        adapterSelect->setObjectName(QString::fromUtf8("adapterSelect"));

        gridLayout->addWidget(adapterSelect, 0, 2, 1, 2);

        textLabel8 = new QLabel(widget);
        textLabel8->setObjectName(QString::fromUtf8("textLabel8"));
        textLabel8->setWordWrap(false);

        gridLayout->addWidget(textLabel8, 1, 0, 1, 2);

        networkSelect = new QComboBox(widget);
        networkSelect->setObjectName(QString::fromUtf8("networkSelect"));

        gridLayout->addWidget(networkSelect, 1, 2, 1, 2);

        frame3 = new Q3Frame(widget);
        frame3->setObjectName(QString::fromUtf8("frame3"));
        frame3->setFrameShape(QFrame::StyledPanel);
        frame3->setFrameShadow(QFrame::Raised);
        gridLayout1 = new QGridLayout(frame3);
        gridLayout1->setSpacing(6);
        gridLayout1->setContentsMargins(11, 11, 11, 11);
        gridLayout1->setObjectName(QString::fromUtf8("gridLayout1"));
        textLabel1 = new QLabel(frame3);
        textLabel1->setObjectName(QString::fromUtf8("textLabel1"));
        textLabel1->setWordWrap(false);

        gridLayout1->addWidget(textLabel1, 0, 0, 1, 1);

        textLabel2 = new QLabel(frame3);
        textLabel2->setObjectName(QString::fromUtf8("textLabel2"));
        textLabel2->setWordWrap(false);

        gridLayout1->addWidget(textLabel2, 1, 0, 1, 1);

        textLabel3 = new QLabel(frame3);
        textLabel3->setObjectName(QString::fromUtf8("textLabel3"));
        textLabel3->setWordWrap(false);

        gridLayout1->addWidget(textLabel3, 2, 0, 1, 1);

        textLabel4 = new QLabel(frame3);
        textLabel4->setObjectName(QString::fromUtf8("textLabel4"));
        textLabel4->setWordWrap(false);

        gridLayout1->addWidget(textLabel4, 3, 0, 1, 1);

        textLabel5 = new QLabel(frame3);
        textLabel5->setObjectName(QString::fromUtf8("textLabel5"));
        textLabel5->setWordWrap(false);

        gridLayout1->addWidget(textLabel5, 4, 0, 1, 1);

        textLabel6 = new QLabel(frame3);
        textLabel6->setObjectName(QString::fromUtf8("textLabel6"));
        textLabel6->setWordWrap(false);

        gridLayout1->addWidget(textLabel6, 5, 0, 1, 1);

        textLabel7 = new QLabel(frame3);
        textLabel7->setObjectName(QString::fromUtf8("textLabel7"));
        textLabel7->setWordWrap(false);

        gridLayout1->addWidget(textLabel7, 6, 0, 1, 1);

        textStatus = new QLabel(frame3);
        textStatus->setObjectName(QString::fromUtf8("textStatus"));
        textStatus->setWordWrap(false);

        gridLayout1->addWidget(textStatus, 0, 1, 1, 1);

        textLastMessage = new QLabel(frame3);
        textLastMessage->setObjectName(QString::fromUtf8("textLastMessage"));
        textLastMessage->setWordWrap(false);

        gridLayout1->addWidget(textLastMessage, 1, 1, 1, 3);

        textAuthentication = new QLabel(frame3);
        textAuthentication->setObjectName(QString::fromUtf8("textAuthentication"));
        textAuthentication->setWordWrap(false);

        gridLayout1->addWidget(textAuthentication, 2, 1, 1, 1);

        textEncryption = new QLabel(frame3);
        textEncryption->setObjectName(QString::fromUtf8("textEncryption"));
        textEncryption->setWordWrap(false);

        gridLayout1->addWidget(textEncryption, 3, 1, 1, 1);

        textSsid = new QLabel(frame3);
        textSsid->setObjectName(QString::fromUtf8("textSsid"));
        textSsid->setWordWrap(false);

        gridLayout1->addWidget(textSsid, 4, 1, 1, 1);

        textBssid = new QLabel(frame3);
        textBssid->setObjectName(QString::fromUtf8("textBssid"));
        textBssid->setWordWrap(false);

        gridLayout1->addWidget(textBssid, 5, 1, 1, 1);

        textIpAddress = new QLabel(frame3);
        textIpAddress->setObjectName(QString::fromUtf8("textIpAddress"));
        textIpAddress->setWordWrap(false);

        gridLayout1->addWidget(textIpAddress, 6, 1, 1, 1);


        gridLayout->addWidget(frame3, 2, 0, 1, 4);

        spacer7 = new QSpacerItem(16, 16, QSizePolicy::Expanding, QSizePolicy::Minimum);

        gridLayout->addItem(spacer7, 3, 0, 1, 1);

        connectButton = new QPushButton(widget);
        connectButton->setObjectName(QString::fromUtf8("connectButton"));

        gridLayout->addWidget(connectButton, 3, 1, 1, 1);

        disconnectButton = new QPushButton(widget);
        disconnectButton->setObjectName(QString::fromUtf8("disconnectButton"));

        gridLayout->addWidget(disconnectButton, 3, 2, 1, 1);

        scanButton = new QPushButton(widget);
        scanButton->setObjectName(QString::fromUtf8("scanButton"));

        gridLayout->addWidget(scanButton, 3, 3, 1, 1);

        WpaGui->setCentralWidget(widget);
        MenuBar = new QMenuBar(WpaGui);
        MenuBar->setObjectName(QString::fromUtf8("MenuBar"));
        fileMenu = new QMenu(MenuBar);
        fileMenu->setObjectName(QString::fromUtf8("fileMenu"));
        helpMenu = new QMenu(MenuBar);
        helpMenu->setObjectName(QString::fromUtf8("helpMenu"));

        MenuBar->addAction(fileMenu->menuAction());
        MenuBar->addAction(helpMenu->menuAction());
        fileMenu->addSeparator();
        fileMenu->addAction(fileEventHistoryAction);
        fileMenu->addAction(fileAdd_NetworkAction);
        fileMenu->addAction(fileEdit_networkAction);
        fileMenu->addSeparator();
        fileMenu->addAction(fileExitAction);
        helpMenu->addAction(helpContentsAction);
        helpMenu->addAction(helpIndexAction);
        helpMenu->addSeparator();
        helpMenu->addAction(helpAboutAction);

        retranslateUi(WpaGui);
        QObject::connect(helpIndexAction, SIGNAL(activated()), WpaGui, SLOT(helpIndex()));
        QObject::connect(helpContentsAction, SIGNAL(activated()), WpaGui, SLOT(helpContents()));
        QObject::connect(helpAboutAction, SIGNAL(activated()), WpaGui, SLOT(helpAbout()));
        QObject::connect(fileExitAction, SIGNAL(activated()), WpaGui, SLOT(close()));
        QObject::connect(disconnectButton, SIGNAL(clicked()), WpaGui, SLOT(disconnect()));
        QObject::connect(scanButton, SIGNAL(clicked()), WpaGui, SLOT(scan()));
        QObject::connect(connectButton, SIGNAL(clicked()), WpaGui, SLOT(connectB()));
        QObject::connect(fileEventHistoryAction, SIGNAL(activated()), WpaGui, SLOT(eventHistory()));
        QObject::connect(networkSelect, SIGNAL(activated(QString)), WpaGui, SLOT(selectNetwork(QString)));
        QObject::connect(fileEdit_networkAction, SIGNAL(activated()), WpaGui, SLOT(editNetwork()));
        QObject::connect(fileAdd_NetworkAction, SIGNAL(activated()), WpaGui, SLOT(addNetwork()));
        QObject::connect(adapterSelect, SIGNAL(activated(QString)), WpaGui, SLOT(selectAdapter(QString)));

        QMetaObject::connectSlotsByName(WpaGui);
    } // setupUi

    void retranslateUi(Q3MainWindow *WpaGui)
    {
        WpaGui->setWindowTitle(QApplication::translate("WpaGui", "wpa_gui", 0, QApplication::UnicodeUTF8));
        fileExitAction->setIconText(QApplication::translate("WpaGui", "Exit", 0, QApplication::UnicodeUTF8));
        fileExitAction->setText(QApplication::translate("WpaGui", "E&xit", 0, QApplication::UnicodeUTF8));
        fileExitAction->setShortcut(QApplication::translate("WpaGui", "Ctrl+Q", 0, QApplication::UnicodeUTF8));
        helpContentsAction->setIconText(QApplication::translate("WpaGui", "Contents", 0, QApplication::UnicodeUTF8));
        helpContentsAction->setText(QApplication::translate("WpaGui", "&Contents...", 0, QApplication::UnicodeUTF8));
        helpContentsAction->setShortcut(QString());
        helpIndexAction->setIconText(QApplication::translate("WpaGui", "Index", 0, QApplication::UnicodeUTF8));
        helpIndexAction->setText(QApplication::translate("WpaGui", "&Index...", 0, QApplication::UnicodeUTF8));
        helpIndexAction->setShortcut(QString());
        helpAboutAction->setIconText(QApplication::translate("WpaGui", "About", 0, QApplication::UnicodeUTF8));
        helpAboutAction->setText(QApplication::translate("WpaGui", "&About", 0, QApplication::UnicodeUTF8));
        helpAboutAction->setShortcut(QString());
        fileEventHistoryAction->setIconText(QApplication::translate("WpaGui", "Event History", 0, QApplication::UnicodeUTF8));
        fileEventHistoryAction->setText(QApplication::translate("WpaGui", "Event &History", 0, QApplication::UnicodeUTF8));
        fileAdd_NetworkAction->setIconText(QApplication::translate("WpaGui", "Add Network", 0, QApplication::UnicodeUTF8));
        fileAdd_NetworkAction->setText(QApplication::translate("WpaGui", "&Add Network", 0, QApplication::UnicodeUTF8));
        fileEdit_networkAction->setIconText(QApplication::translate("WpaGui", "Edit Network", 0, QApplication::UnicodeUTF8));
        fileEdit_networkAction->setText(QApplication::translate("WpaGui", "&Edit Network", 0, QApplication::UnicodeUTF8));
        textLabel16->setText(QApplication::translate("WpaGui", "Adapter:", 0, QApplication::UnicodeUTF8));
        textLabel8->setText(QApplication::translate("WpaGui", "Network:", 0, QApplication::UnicodeUTF8));
        textLabel1->setText(QApplication::translate("WpaGui", "Status:", 0, QApplication::UnicodeUTF8));
        textLabel2->setText(QApplication::translate("WpaGui", "Last message:", 0, QApplication::UnicodeUTF8));
        textLabel3->setText(QApplication::translate("WpaGui", "Authentication:", 0, QApplication::UnicodeUTF8));
        textLabel4->setText(QApplication::translate("WpaGui", "Encryption:", 0, QApplication::UnicodeUTF8));
        textLabel5->setText(QApplication::translate("WpaGui", "SSID:", 0, QApplication::UnicodeUTF8));
        textLabel6->setText(QApplication::translate("WpaGui", "BSSID:", 0, QApplication::UnicodeUTF8));
        textLabel7->setText(QApplication::translate("WpaGui", "IP address:", 0, QApplication::UnicodeUTF8));
        textStatus->setText(QString());
        textLastMessage->setText(QString());
        textAuthentication->setText(QString());
        textEncryption->setText(QString());
        textSsid->setText(QString());
        textBssid->setText(QString());
        textIpAddress->setText(QString());
        connectButton->setText(QApplication::translate("WpaGui", "Connect", 0, QApplication::UnicodeUTF8));
        disconnectButton->setText(QApplication::translate("WpaGui", "Disconnect", 0, QApplication::UnicodeUTF8));
        scanButton->setText(QApplication::translate("WpaGui", "Scan", 0, QApplication::UnicodeUTF8));
        fileMenu->setTitle(QApplication::translate("WpaGui", "&File", 0, QApplication::UnicodeUTF8));
        helpMenu->setTitle(QApplication::translate("WpaGui", "&Help", 0, QApplication::UnicodeUTF8));
    } // retranslateUi

};

namespace Ui {
    class WpaGui: public Ui_WpaGui {};
} // namespace Ui

QT_END_NAMESPACE

class WpaGui : public Q3MainWindow, public Ui::WpaGui
{
    Q_OBJECT

public:
    WpaGui(QWidget* parent = 0, const char* name = 0, Qt::WindowFlags fl = Qt::WType_TopLevel);
    ~WpaGui();

    virtual int ctrlRequest( const char * cmd, char * buf, size_t * buflen );
    virtual void triggerUpdate();

public slots:
    virtual void parse_argv();
    virtual void updateStatus();
    virtual void updateNetworks();
    virtual void helpIndex();
    virtual void helpContents();
    virtual void helpAbout();
    virtual void disconnect();
    virtual void scan();
    virtual void eventHistory();
    virtual void ping();
    virtual void processMsg( char * msg );
    virtual void processCtrlReq( const char * req );
    virtual void receiveMsgs();
    virtual void connectB();
    virtual void selectNetwork( const QString & sel );
    virtual void editNetwork();
    virtual void addNetwork();
    virtual void selectAdapter( const QString & sel );

protected slots:
    virtual void languageChange();

private:
    ScanResults *scanres;
    bool networkMayHaveChanged;
    char *ctrl_iface;
    EventHistory *eh;
    struct wpa_ctrl *ctrl_conn;
    QSocketNotifier *msgNotifier;
    QTimer *timer;
    int pingsToStatusUpdate;
    WpaMsgList msgs;
    char *ctrl_iface_dir;
    struct wpa_ctrl *monitor_conn;
    UserDataRequest *udr;

    void init();
    void destroy();
    int openCtrlConnection( const char * ifname );

};

#endif // WPAGUI_H
